#!/usr/bin/env perl
-#
-# $Cambridge: exim/release-process/scripts/mk_exim_release.pl,v 1.1 2010/06/03 12:00:38 nm4 Exp $
-#
+# Copyright (c) The Exim Maintainers 2016
+
use strict;
use warnings;
use Carp;
use File::Temp;
use FindBin;
use Getopt::Long;
+use IO::File;
use Pod::Usage;
my $debug = 0;
my $context = shift;
# make sure this looks like a real release version
- # which should (currently) be 4.xx or 4.xx_RCx
- unless ( $release =~ /^(4\.\d\d(?:_RC\d+)?)$/ ) {
+ # which should (currently) be 4.xx[.y] or 4.xx[.y]_RCx
+ unless ( $release =~ /^(?<release>(?<major>4\.\d\d)(?:\.(?<minor>\d+))?(?:_RC\d+)?)$/ ) {
croak "The given version number does not look right - $release";
}
- my $full_release = $1; # untainted here...
- my $trunc_release = $full_release;
- $trunc_release =~ s/^(4\.\d\d)(?:_RC\d+)?$/$1/;
+ $context->{release} = $+{release};
+ $context->{major} = $+{major};
+ $context->{minor} = $+{minor};
- $context->{release} = $full_release;
- $context->{trelease} = $trunc_release;
+ ($context->{trelease} = $+{release}) =~ s/_RC\d+//;
}
# ------------------------------------------------------------------
mkpath( $context->{directory}, { verbose => ( $verbose || $debug ) } );
# set and create subdirectories
- foreach (qw(release_tree pkgs pkgdirs docbook)) {
+ foreach (qw(release_tree pkgs pkgdirs docbook tmp)) {
$context->{$_} = File::Spec->catdir( $context->{directory}, $_ );
mkpath( $context->{$_}, { verbose => ( $verbose || $debug ) } );
}
my $context = shift;
# build git command
- my $archive_file = sprintf( '%s/%s-%s.tar', $context->{tmp_dir}, $context->{pkgname}, $context->{release} );
+ my $archive_file = sprintf( '%s/%s-%s.tar', $context->{tmp}, $context->{pkgname}, $context->{release} );
$context->{tmp_archive_file} = $archive_file;
my @cmd = ( 'git', 'archive', '--format=tar', "--output=$archive_file", $context->{tag} );
-
# run git command
print( "Running: ", join( ' ', @cmd ), "\n" ) if ($verbose);
system(@cmd) == 0 || croak "Export failed";
# ------------------------------------------------------------------
+sub make_version_script {
+ my $context = shift;
+
+ my $variant = substr( $context->{release}, length($context->{trelease}) );
+ if ( $context->{release} ne $context->{trelease} . $variant ) {
+ die "Broken version numbering, I'm buggy";
+ }
+
+ my $srcdir = File::Spec->catdir( $context->{release_tree}, 'src', 'src' );
+ chdir $srcdir or die "chdir $srcdir: $!\n";
+
+ if ( -f "version.sh" ) {
+ print( "WARNING: version.sh already exists - leaving it in place\n" );
+ return;
+ }
+
+ # Currently (25. Feb. 2016) the mk_exim_release.pl up to now can't
+ # deal with security releases.!? So we need a current
+ # mk_exim_release.pl. But if we use a current (master), the
+ # reversion script returns wrong version info (it's running inside
+ # the Git tree and uses git --describe, which always returns the
+ # current version of master.) I do not want to change the old
+ # reversion scripts (in 4.86.1, 4.85.1).
+ #
+ # Thus we've to provide the version.sh, based on the info we have
+ # about the release. If reversion finds this, it doesn't try to find
+ # it's own way to get a valid version number from the git.
+ open(my $v, '>', 'version.sh') or die "Can't open '>version.sh' $!\n";
+ print {$v} <<__;
+# initial version automatically generated from $0
+EXIM_RELEASE_VERSION=$context->{major}
+EXIM_VARIANT_VERSION=@{[$context->{minor}?'_'.$context->{minor}:'']}
+EXIM_COMPILE_NUMBER=0
+__
+ close($v);
+ unlink 'version.h';
+ return;
+
+ # Later, if we get the reversion script fixed, we can call it again.
+ # For now (25. Feb. 2016) we'll leave it unused.
+ my @cmd = ("../scripts/reversion", "release", $context->{tag});
+ print( "Running: ", join( ' ', @cmd ), "\n" ) if ($verbose);
+ system(@cmd) == 0 || croak "reversion failed";
+
+ unlink "version.h";
+
+ -f "version.sh" or die "failed to create version.sh";
+}
+
+# ------------------------------------------------------------------
+
sub build_html_documentation {
my $context = shift;
mkdir($dir);
- my @cmd =
- ( $genpath, '--spec', $spec, '--filter', $filter, '--latest', $context->{trelease}, '--tmpl', $templates, '--docroot', $dir );
+ my @cmd = (
+ $genpath, '--spec', $spec, '--filter',
+ $filter, '--latest', $context->{trelease}, '--tmpl',
+ $templates, '--docroot', $dir, '--localstatic'
+ );
+ push @cmd, '--verbose' if $verbose or $debug;
print "Executing ", join( ' ', @cmd ), "\n";
system(@cmd);
my $context = shift;
my $docdir = File::Spec->catdir( $context->{release_tree}, 'doc', 'doc-docbook' );
- system("cd '$docdir' && ./OS-Fixups && make everything") == 0
+ # documentation building gets the truncated release, without RC
+ system("cd '$docdir' && ./OS-Fixups && $context->{make_cmd} EXIM_VER=$context->{trelease} everything") == 0
|| croak "Doc build failed";
copy_docbook_files($context);
sub move_text_docs_into_pkg {
my $context = shift;
- my $old_docdir = File::Spec->catdir( $context->{eximpkgdir}, 'doc', 'doc-docbook' );
+ my $old_docdir = File::Spec->catdir( $context->{release_tree}, 'doc', 'doc-docbook' );
+ my $old_txtdir = File::Spec->catdir( $context->{release_tree}, 'doc', 'doc-txt' );
my $new_docdir = File::Spec->catdir( $context->{eximpkgdir}, 'doc' );
mkpath( $new_docdir, { verbose => ( $verbose || $debug ) } );
}
# move text documents across
- foreach my $file ( glob( File::Spec->catfile( 'doc/doc-txt', '*' ) ) ) {
+ foreach my $file ( glob( File::Spec->catfile( $old_txtdir, '*' ) ) ) {
# skip a few we dont want
my $fn = ( File::Spec->splitpath($file) )[2];
next
if ( ( $fn eq 'ABOUT' )
|| ( $fn eq 'ChangeLog.0' )
- || ( $fn eq 'test-harness.txt' ) );
+ || ( $fn eq 'test-harness.txt' )
+ # Debian issue re licensing of RFCs
+ || ( $fn =~ /^draft-ietf-.*/ )
+ || ( $fn =~ /^rfc.*/ )
+ );
move( $file, File::Spec->catfile( $new_docdir, $fn ) );
}
}
my $context = shift;
build_main_package_directory($context);
- build_pspdfinfo_directory($context);
+ build_pspdfinfo_directory($context) if $context->{build_docs};
}
# ------------------------------------------------------------------
my $context = shift;
print "Cleaning up\n" if ($verbose);
+ chdir( $context->{directory} ) || die;
rmtree( $context->{release_tree}, { verbose => $debug } );
rmtree( $context->{docbook}, { verbose => $debug } );
rmtree( $context->{pkgdirs}, { verbose => $debug } );
# ------------------------------------------------------------------
+# We prefer gtar to tar if gtar exists in $PATH
+
+sub fix_paths_tar {
+ my $context = shift;
+ my $tar = $context->{tar_cmd};
+
+ return unless $tar eq 'tar';
+
+ foreach my $d (File::Spec->path()) {
+ my $p = File::Spec->catfile($d, 'gtar');
+ if (-x $p) {
+ $context->{tar_cmd} = $p;
+ print "Switched tar command to: $p\n" if ($verbose);
+ return;
+ }
+ }
+}
+
+# ------------------------------------------------------------------
+
sub create_tar_files {
my $context = shift;
my $pkgs = $context->{pkgs};
my $pkgdirs = $context->{pkgdirs};
+ my $tar = $context->{tar_cmd};
+ if ($verbose) {
+ foreach my $c (keys %{ $context->{compressors} }) {
+ print "Compression: $c\t$context->{compressors}{$c}\n";
+ }
+ }
+
foreach my $dir ( glob( File::Spec->catdir( $pkgdirs, ( 'exim*-' . $context->{release} ) ) ) ) {
my $dirname = ( File::Spec->splitdir($dir) )[-1];
- system("tar cfz ${pkgs}/${dirname}.tar.gz -C ${pkgdirs} ${dirname}");
- system("tar cfj ${pkgs}/${dirname}.tar.bz2 -C ${pkgdirs} ${dirname}");
+ if ($context->{compressors}{gzip}) {
+ print "Creating: ${pkgs}/${dirname}.tar.gz\n" if ($verbose || $debug);
+ system("$tar cf ${pkgs}/${dirname}.tar.gz --gzip -C ${pkgdirs} ${dirname}")
+ }
+ if ($context->{compressors}{bzip2}) {
+ print "Creating: ${pkgs}/${dirname}.tar.bz2\n" if ($verbose || $debug);
+ system("$tar cf ${pkgs}/${dirname}.tar.bz2 --bzip2 -C ${pkgdirs} ${dirname}")
+ }
+ if ($context->{compressors}{lzip}) {
+ print "Creating: ${pkgs}/${dirname}.tar.lz\n" if ($verbose || $debug);
+ system("$tar cf ${pkgs}/${dirname}.tar.lz --lzip -C ${pkgdirs} ${dirname}")
+ }
}
}
orig_dir => File::Spec->curdir(),
tmp_dir => File::Temp->newdir(),
webgen_base => "$FindBin::Bin/../../../exim-website",
+ tar_cmd => 'tar',
+ make_cmd => 'make',
+ compressors => {
+ gzip => 1,
+ bzip2 => 1,
+ lzip => 0,
+ },
+ build_docs => 1,
};
my $delete;
my $cleanup = 1;
GetOptions(
'directory=s' => \$context->{directory},
'webgen_base=s' => \$context->{webgen_base},
+ 'tar=s' => \$context->{tar_cmd},
+ 'make=s' => \$context->{make_cmd},
+ 'lzip!' => \$context->{compressors}{lzip},
'verbose!' => \$verbose,
'debug!' => \$debug,
'help|?' => \$help,
'man!' => \$man,
'delete!' => \$delete,
'cleanup!' => \$cleanup,
+ 'build-docs!' => \$context->{build_docs},
)
)
{
pod2usage( -verbose => 2 ) if $man;
get_and_check_version( shift, $context );
+ fix_paths_tar($context);
$context->{tag} = build_tag($context);
deal_with_working_directory( $context, $delete );
export_git_tree($context);
chdir( $context->{directory} ) || die;
unpack_tree($context);
- build_documentation($context);
+ make_version_script($context);
+ build_documentation($context) if $context->{build_docs};
build_package_directories($context);
create_tar_files($context);
do_cleanup($context) if ($cleanup);
mk_exim_release.pl [options] version
Options:
- --debug force debug mode (SQL Trace)
+ --debug force debug mode
--verbose force verbose mode
--help display this help and exits
--man displays man page
+ --tar=cmd command to use for tar
+ --make=cmd command to use for make
--directory=dir dir to package
+ --no-lzip do not create .tar.lz files
--delete Delete packaging directory at start
+ --noweb skip the website generation
=head1 OPTIONS
=item B<--debug>
-Forces debug mode cause all SQL statements generated by L<DBIx::Class>
-to be output.
+Forces debug mode.
+
+=item B<--tar>
+
+Use to override the path to the tar command; without this, will search for
+gtar, and if not found use tar. Need GNU tar for lzip, unless --no-lzip is
+used.
+
+=item B<--make>
+
+Use to override the path/name of the make command.
+Useful sometimes to force gmake.
+
+=item B<--lzip>
+
+Build the lzip tarballs.
=item B<--verbose>
-Force verbose mode - currently this has no effect
+Force verbose mode
=item B<--help>
Starting in a populated git repo that has already been tagged for
release, build docs, build packages etc.
-Parameter is the version number to build as - ie 4.72 4.72RC1 etc
+Parameter is the version number to build as - ie 4.72 4.72RC1, 4.86.1, etc
=head1 AUTHOR
Copyright 2010 Exim Maintainers. All rights reserved.
=cut
+# vim: set sw=4 et :